package com.lyg.application.entity;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 分类;
 *
 * @author : http://www.chiner.pro
 * @date : 2024-3-22
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "分类", description = "")
@TableName("td_category")
public class TaCategory implements Serializable, Cloneable {

    @ApiModelProperty(name = "分类Id", notes = "")
    @TableId(value = "category_id", type = IdType.ASSIGN_UUID)
    private String categoryId;

    @NotBlank(message = "分类名不能为空")
    @ApiModelProperty(name = "分类名", notes = "")
    private String categoryName;

    @ApiModelProperty(name = "上级单位;-1为根级目录", notes = "")
    private String parentId;

    @ApiModelProperty(name = "序号", notes = "")
    private Integer sort;

    @ApiModelProperty(name = "状态", notes = "0 正常 1不正常")
    private Integer status;

    @ApiModelProperty(name = "", notes = "")
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createdTime;

    @ApiModelProperty(name = "", notes = "")
    @TableField(fill = FieldFill.INSERT)
    private String createdBy;

    @ApiModelProperty(name = "", notes = "")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedTime;

    @ApiModelProperty(name = "", notes = "")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updatedBy;

    @ApiModelProperty(name = "", notes = "0 存在 1 删除")
    @TableField(fill = FieldFill.INSERT)
    private Integer deleted;

}