package com.lyg.application.service.impl;

import com.lyg.application.entity.TaAttach;
import com.lyg.application.entity.TaPost;
import com.lyg.application.entity.TaSourceAttach;
import com.lyg.application.mapper.TaAttachMapper;
import com.lyg.application.mapper.TaPostMapper;
import com.lyg.application.mapper.TaSourceAttachMapper;
import com.lyg.application.service.TaAttachService;
import com.lyg.application.service.TaPostService;
import com.lyg.common.util.StringUtil;
import com.lyg.system.service.impl.BaseServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * 文章;(ta_post)表服务实现类
 *
 * @author : http://www.chiner.pro
 * @date : 2024-3-22
 */
@Service
public class TaPostServiceImpl extends BaseServiceImpl<TaPostMapper, TaPost> implements TaPostService {


    @Autowired
    TaSourceAttachMapper taSourceAttachMapper;
    @Autowired
    TaAttachService taAttachService;
    @Autowired
    TaAttachMapper taAttachMapper;

    @Override
    public void savePost(TaPost taPost) {
        String sourceAttachId = StringUtil.UUID();
        String attachId = StringUtil.UUID();
        String postId = StringUtil.UUID();

        TaSourceAttach taSourceAttach = new TaSourceAttach();
        taSourceAttach.setSourceAttachId(sourceAttachId);
        taSourceAttach.setSourceId(postId);
        taSourceAttach.setSourceName("taPost");
        taSourceAttach.setAttachId(attachId);
        taSourceAttachMapper.insert(taSourceAttach);


        //保存所有的附件
        List<TaAttach> taAttachList = new ArrayList<>();
        for (TaAttach item : taPost.getTaAttachList()) {
            item.setAttachId(attachId);
            taAttachList.add(item);
        }

        taAttachService.saveBatch(taAttachList);


    }

    @Override
    public TaPost getByPostId(String id) {

        String attachId = taSourceAttachMapper.getAttachIdBySourceId(id);

        List<TaAttach> taAttachList = taAttachMapper.getAttachList(attachId);


        TaPost taPost = baseMapper.selectById(id);
        taPost.setTaAttachList(taAttachList);
        return taPost;
    }
}